require 'rflow/components/amqp/extensions'
require 'rflow/components/amqp/subscriber'

# RFlow classes.
class RFlow
  # RFlow component classes.
  module Components
    # AMQP RFlow component classes.
    module AMQP
      # Load the schemas
      # @!visibility private
      SCHEMA_DIRECTORY = ::File.expand_path(::File.join(::File.dirname(__FILE__), '..', '..', '..', 'schema'))

      # @!visibility private
      SCHEMA_FILES = {
        'amqp_message.avsc'  => 'RFlow::Message::Data::AMQP::Message',
      }

      SCHEMA_FILES.each do |file_name, data_type_name|
        schema_string = ::File.read(::File.join(SCHEMA_DIRECTORY, file_name))
        RFlow::Configuration.add_available_data_type data_type_name, 'avro', schema_string
      end

      # Load the data extensions
      RFlow::Configuration.add_available_data_extension('RFlow::Message::Data::AMQP::Message',
                                                        RFlow::Components::AMQP::Extensions::AMQPMessageExtension)
    end
  end
end
