class RFlow
  module Components
    module AMQP
      # @!visibility private
      module Extensions
        # @!visibility private
        module AMQPMessageExtension
          # @!visibility private
          def self.extended(base_data)
            base_data.data_object ||= {'header' => {}, 'payload' => ''}
          end

          # Default accessors
          ['header', 'payload'].each do |name|
            define_method name do |*args|
              data_object[name]
            end
            define_method :"#{name}=" do |*args|
              data_object[name] = args.first
            end
          end
        end
      end
    end
  end
end
